\begin{code}

module MutableVar
	( MutableVar
	  -- instance Eq (MutableVar s a)
	, newVar
	, readVar
	, writeVar 

	, ST
	) where

import qualified ST( MutVar, newVar, readVar, writeVar )

newtype MutableVar s a = MutableVar (ST.MutVar s a) deriving (Eq)

unM :: MutableVar s a -> ST.MutVar s a
unM (MutableVar x) = x

newVar   :: a -> ST s (MutableVar s a)
readVar  :: MutableVar s a -> ST s a
writeVar :: MutableVar s a -> a -> ST s ()

newVar a     = do { v <- ST.newVar a; return (MutableVar v) }
readVar  v   = ST.readVar  (unM v)
writeVar v a = ST.writeVar (unM v) a

\end{code}

